require "spec_helper"

module Sidewatch

  describe Metric do

    let(:namespace){ "Clocks" }
    let(:metric_name){ "Ticks" }
    let(:metric_value){ 1234 }
    let(:metric_unit){ "Count" }
    let(:dimensions){ { "ClockName" => "cuckoo" } }
    let(:timestamp){ Time.at(1440494300) }
    subject {
      described_class.new(
        name: metric_name,
        value: metric_value,
        unit: metric_unit,
        dimensions: dimensions,
        timestamp: timestamp,
      )
    }

    describe "#initialize" do

      context "missing timestamp" do
        let(:timestamp){ nil }
        it "sets a default timestamp" do
          expect(subject.timestamp).to_not be_nil
        end
      end

    end
  end
end
